<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2024 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2024-09-30
 */
define('IN_DOUCO', true);

$_CUR = 'form';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// 如果已经有数据提交，则直接显示数据页面
if ($dou->num_rows($dou->query("SELECT * FROM " . $dou->table('form_data')))) {
    $rec = 'form_data_list';
} else {
    $rec = 'form_list';
}

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : $rec;
$act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'elements_add';

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/form/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 载入并实例化类库
require (ROOT_PATH . 'include/form.class.php');
$form = new Form();

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('act', $act);

/**
 * +----------------------------------------------------------
 * 表单列表
 * +----------------------------------------------------------
 */
if ($rec == 'form_list') {
    $smarty->assign('ur_here', $_LANG['form']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['form_add'],
            'href' => 'form.php?rec=add' 
    ));
    
    // 获取参数
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    if ($keyword) {
        $where = " WHERE name LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('form') . $where . " ORDER BY form_id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, 'form.php?rec=form_list', $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $form_list[] = array (
                "form_id" => $row['form_id'],
                "name" => $row['name'],
                "image" => $dou->dou_file($row['image']),
                "status" => $dou->data_lang_format('form_status_', $row['status']),
                "url" => $dou->param($dou->rewrite_url('form') . '&id=' . $row['form_id']),
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('form_list', $form_list);
    
    $smarty->display('form.htm');
} 

/**
 * +----------------------------------------------------------
 * 表单添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['form_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['form'],
            'href' => 'form.php?rec=form_list' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    
    $smarty->display('form.htm');
} 

elseif ($rec == 'insert') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['form_name'] . $_LANG['is_empty']);

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    // 文件上传盒子
    $image = $file->box('form', $dou->auto_id('form'), 'image', 'main');
    
    $sql = "INSERT INTO " . $dou->table('form') . " (form_id, name, unique_id, content, image, back_url, status)" . " VALUES (NULL, '$_POST[name]', '$_POST[unique_id]', '$_POST[content]', '$image', '$_POST[back_url]', '$_POST[status]')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['form_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['form_add'] . $_LANG['success'], 'form.php?rec=form_list');
} 

/**
 * +----------------------------------------------------------
 * 表单编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['form_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['form_list'],
            'href' => 'form.php?rec=form_list' 
    ));
 
    // 验证并获取合法的ID
    $form_id = $check->is_number($_REQUEST['form_id']) ? $_REQUEST['form_id'] : '';
    
    // 获取表单信息
    $form_info = $dou->get_row('form', '*', "form_id = '$form_id'");
    
    // 格式化数据
    $form_info['image'] = $dou->dou_file($form_info['image']);
    
    // 赋值给模板
    $smarty->assign('form_elements_list', $form->get_form_elements_list($form_id));
    
    // 自定义选项添加
    if ($act == 'elements_add') {
        // 赋值给模板
        $smarty->assign('elements_form_action', 'elements_insert');
        $smarty->assign('form_elements_type', $dou->data_list_lang_format('form_elements_type_', 'input, select, textarea, radio'));
    }
 
    // 自定义选项编辑
    elseif ($act == 'elements_edit') {
        // 获取REQUEST
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        $elements = $dou->get_row('form_elements', '*', "id = '$id'");
        
        // 赋值给模板
        $smarty->assign('elements', $elements);
        $smarty->assign('elements_form_action', 'elements_update');
        $smarty->assign('form_elements_type', $dou->data_list_lang_format('form_elements_type_', 'input, select, textarea, radio', $elements['type']));
    } 
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('form', $form_info);
    
    $smarty->display('form.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $form_id = $check->is_number($_POST['form_id']) ? $_POST['form_id'] : exit;
    
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['form_name'] . $_LANG['is_empty']);

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    // 文件上传盒子
    $image = $file->box('form', $form_id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';
    
    $sql = "UPDATE " . $dou->table('form') . " SET name = '$_POST[name]', unique_id = '$_POST[unique_id]', content = '$_POST[content]'" . $image . ", back_url = '$_POST[back_url]', status = '$_POST[status]' WHERE form_id = '$form_id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['form_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['form_edit_succes'], 'form.php?rec=edit&form_id=' . $form_id);
}

/**
 * +----------------------------------------------------------
 * 表单删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $form_id = $check->is_number($_REQUEST['form_id']) ? $_REQUEST['form_id'] : $dou->dou_msg($_LANG['illegal'], 'form.php?rec=form_list');
 
    $name = $dou->get_one("SELECT name FROM " . $dou->table('form') . " WHERE form_id = '$form_id'");
    
    if (isset($_POST['confirm']) ? $_POST['confirm'] : '') {
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('form') . " WHERE form_id = '$form_id'");
        $dou->del_file($image);
         
        $dou->create_admin_log($_LANG['form_del'] . ': ' . $name);
        $dou->delete('form', "form_id = $form_id", 'form.php?rec=form_list');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'form.php?rec=form_list', '', '30', "form.php?rec=del&form_id=$form_id");
    }
}

/**
 * +----------------------------------------------------------
 * 自定义选项添加处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'elements_insert') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['form_elements_name'] . $_LANG['is_empty']);

    if (!$check->is_unique_id($_POST['unique_id']))
        $dou->dou_msg($_LANG['unique_id_wrong']);

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);

    $sql = "INSERT INTO " . $dou->table('form_elements') . " (id, form_id, name, unique_id, type, unit, sort, must_fill, `option`)" . " VALUES (NULL, '$_POST[form_id]', '$_POST[name]', '$_POST[unique_id]', '$_POST[type]', '$_POST[unit]', '$_POST[sort]', '$_POST[must_fill]', '$_POST[option]')";
    $dou->query($sql);

    $dou->create_admin_log($_LANG['form_elements_add'] . ': ' . $_POST['name']);
    $dou->dou_header('form.php?rec=edit&form_id=' . $_POST['form_id']);
}

/**
 * +----------------------------------------------------------
 * 自定义选项编辑处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'elements_update') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['form_elements_name'] . $_LANG['is_empty']);

    if (!$check->is_unique_id($_POST['unique_id']))
        $dou->dou_msg($_LANG['unique_id_wrong']);

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);

    $sql = "UPDATE " . $dou->table('form_elements') . " SET name = '$_POST[name]', unique_id = '$_POST[unique_id]', type = '$_POST[type]', unit = '$_POST[unit]', sort = '$_POST[sort]', must_fill = '$_POST[must_fill]', `option` = '$_POST[option]' WHERE id = '$_POST[id]'";
    $dou->query($sql);

    $dou->create_admin_log($_LANG['form_elements_edit'] . ': ' . $_POST['name']);
    $dou->dou_header('form.php?rec=edit&form_id=' . $_POST['form_id']);
}    

/**
 * +----------------------------------------------------------
 * 自定义选项删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'elements_del') {
    // 验证并获取合法的ID
    $form_id = $check->is_number($_REQUEST['form_id']) ? $_REQUEST['form_id'] : $dou->dou_msg($_LANG['illegal'], 'form.php');
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'form.php?rec=edit&form_id=' . $form_id);
 
    $name = $dou->get_one("SELECT name FROM " . $dou->table('form_elements') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm']) ? $_POST['confirm'] : '') {
        $dou->create_admin_log($_LANG['form_elements_del'] . ': ' . $name);
        $dou->delete('form_elements', "id = $id", 'form.php?rec=edit&form_id=' . $form_id);
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], "form.php?rec=edit&form_id=$form_id", '', '30', "form.php?rec=elements_del&form_id=$form_id&id=$id");
    }
}

/**
 * +----------------------------------------------------------
 * 数据列表
 * +----------------------------------------------------------
 */
if ($rec == 'form_data_list') {
    $smarty->assign('ur_here', $_LANG['form_data_list']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['form_list'],
            'href' => 'form.php?rec=form_list' 
    ));
    
    // 获取参数
    $form_id = $check->is_number($_REQUEST['form_id']) ? $_REQUEST['form_id'] : 0;
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    $where = $form_id ? " AND form_id = '$form_id'" : '';
    if ($keyword) {
        $where = " AND data_box LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
    
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('form_data') . $where . " ORDER BY id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'form.php?rec=form_data_list' . ($form_id ? '&form_id=' . $form_id : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $form_data_list[] = array (
                "id" => $row['id'],
                "form" => $dou->get_row('form', 'form_id, name', "form_id = '$row[form_id]'"),
                "data_box" => $form->format_data_box($row['form_id'], $row['data_box']),
                "ip" => $row['ip'],
                "if_read" => $row['if_read'],
                "status" => $dou->data_lang_format('form_data_status_', $row['status']),
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('form_data_list', $form_data_list);
    $smarty->assign('form_list', $form->get_form_list($form_id));
    
    $smarty->display('form.htm');
}

/**
 * +----------------------------------------------------------
 * 数据查看
 * +----------------------------------------------------------
 */
elseif ($rec == 'form_data') {
    // 表单ID
    $form_id = $check->is_number($_REQUEST['form_id']) ? $_REQUEST['form_id'] : '';
    $back_url = 'form.php?rec=form_data_list' . ($form_id ? "&form_id=$form_id" : '');
 
    $smarty->assign('ur_here', $_LANG['form_data']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['form_data_list'],
            'href' => $back_url 
    ));
 
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    // 获取表单信息
    $form_data = $dou->get_row('form_data', '*', "id = '$id'");
    $form_data['data_box'] = $form->format_data_box($form_data['form_id'], $form_data['data_box']);
    
    // 更新为已读
    $dou->query("UPDATE " . $dou->table('form_data') . " SET if_read = '1' WHERE id = '$id'");
    
    // 赋值给模板
    $smarty->assign('form_data', $form_data);
    
    $smarty->display('form.htm');
}

/**
 * +----------------------------------------------------------
 * 数据处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'form_data_check') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $status = $dou->get_one("SELECT status FROM " . $dou->table('form_data') . " WHERE id = '$id'");
    $status = $status ? 0 : 1;
    
    // 更新状态
    $dou->query("UPDATE " . $dou->table('form_data') . " SET status = '$status' WHERE id = '$id'");
    
    echo "<em class=" . ($status ? 'd' : 'h') . "><b>$_LANG[form_data_status_1]</b><s>$_LANG[form_data_status_0]</s></em>";
}    

/**
 * +----------------------------------------------------------
 * 自定义选项删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'form_data_del') {
    // 验证并获取合法的ID
    $form_id = $check->is_number($_REQUEST['form_id']) ? $_REQUEST['form_id'] : '';
    $back_url = 'form.php?rec=form_data_list' . ($form_id ? "&form_id=$form_id" : '');
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], $back_url);
 
    if (isset($_POST['confirm']) ? $_POST['confirm'] : '') {
        $dou->create_admin_log($_LANG['form_data_del'] . ': ' . $id);
        $dou->delete('form_data', "id = $id", $back_url);
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $id, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], $back_url, '', '30', "form.php?rec=form_data_del&form_id=$form_id&id=$id");
    }
}

?>