// pages/form/detail.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    post_data: [],
    select_index: 0,
    success: false
  },
  
  onLoad: function(options) {
    var that = this
        
    // 显示转发按钮
    dou.showShareMenu()
        
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })

    wx.request({
      url: app.mp_url + 'form.php?rec=detail',
      data: {
        id: options.id,
        post_data: that.data.post_data
      },
      success: function(res) {
        that.setData({
          title: res.data.title,
          form: res.data.form,
          post_data: res.data.post_data
        })
       
        wx.setNavigationBarTitle({
          title: res.data.form.name
        })

        // 设置转发标题缓存
        wx.setStorageSync('shareTitle', res.data.form.name)
      },
    })
  },
 
  formSubmit: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
      url: app.mp_url + 'form.php?rec=submit',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        post: JSON.stringify(e.detail.value),
        post_data: JSON.stringify(that.data.post_data)
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong)
        } else {
          if (res.data.back_url) {
            setTimeout(function () {
              wx.navigateTo({
                url: res.data.back_url
              })
            }, 2000)
          } else {
            dou.douMsg(that.data.lang.consultation_insert_success)

            that.setData({
              success: true
            })
          }
        }
      }
    })
  },
  
  selectChange: function(e) {
    var name = e.currentTarget.dataset.name;
    var post_data = this.data.post_data;
    
    this.setData({
      select_index: e.detail.value,
      [`post_data.${name}`]: e.currentTarget.dataset.option[e.detail.value]
    })
   
    console.log(this.data.post_data)
  },

  // 获取Ridio值
  radioChange: function (e) {
    var name = e.currentTarget.dataset.name;
    var post_data = this.data.post_data;
    
    this.setData({
      [`post_data.${name}`]: e.detail.value
    })
    
    console.log(this.data.post_data)
  },

  // 设置转发标题
  onShareAppMessage: function (options) {
    return {
      title: wx.getStorageSync('shareTitle')
    }
  },

  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  },

  // 只能跳转到tabBar配置页面
  douSwitchTab: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.switchTab({
      url: url
    })
  },

})