<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2024 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2024-09-30
 */
define('IN_DOUCO', true);

$sub = 'detail';
$subbox = array(
        "module" => 'form',
        "sub" => $sub
);

$_CUR = 'form';
require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/form.class.php');
$dou_form = new Form();

// 错误提示初始
$data['wrong'] = '';

/**
 * +----------------------------------------------------------
 * 表单列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('form') . " WHERE status = 1 ORDER BY sort ASC, form_id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, ($_DISPLAY['form'] ? $_DISPLAY['form'] : 12), $page, $dou->rewrite_url('form'));

    /* 获取表单列表 */
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        // 多语言
        $row = $dou->lang_box($row, 'form', 'name, content');
        
        $form_list[] = array (
                "form_id" => $row['form_id'],
                "name" => $row['name'],
                "content" => $row['content'],
                "image" => $dou->dou_file($row['image']),
                "url" => $dou->rewrite_url_miniprogram('form', $row['form_id'])
        );
    }
 
    // 数据封装
    $data['title'] = $_LANG['form'];
    $data['form_list'] = $form_list;
}

/**
 * +----------------------------------------------------------
 * 表单简介
 * +----------------------------------------------------------
 */
if ($rec == 'detail') {
    // 验证并获取合法REQUEST
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';

    /* 获取详细信息 */
    $form = $dou->get_row('form', '*', "form_id = '$id' AND status = '1'");
    
    if ($form) {
        $form['elements_list'] = $dou_form->get_form_elements_list($id);
     
        foreach ($form['elements_list'] as $row) {
            if ($row['type'] == 'radio' || $row['type'] == 'select') {
                $post_data[$row['unique_id']] = $row['option'][0];
            }
        }
    } else {
        $dou->dou_msg($GLOBALS['_LANG']['page_wrong'], HOME_URL);
    }
 
    // 数据封装
    $data['title'] = $form['name'];
    $data['form'] = $form;
    $data['post_data'] = $post_data;
}

/**
 * +----------------------------------------------------------
 * 表单提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'submit') {
    // 格式化POST项
    $_POST = array_merge($_POST, get_object_vars(json_decode(str_replace("\\", "", $_REQUEST['post']))));
    $_POST = array_merge($_POST, get_object_vars(json_decode(str_replace("\\", "", $_REQUEST['post_data']))));
 
    $form_id = $check->is_letter_number($_POST['form_id']) ? $_POST['form_id'] : '';
    
    // 必填项不能为空
    $data_must_fill = $dou->fn_query("SELECT * FROM " . $dou->table('form_elements') . " WHERE form_id = '$form_id' AND must_fill = '1' ORDER BY sort ASC, id ASC");
    foreach ($data_must_fill as $row) {
        if (!$_POST[$row['unique_id']])
            $wrong[$row['unique_id']] = $row['name'] . $_LANG['is_empty'];
    }
 
    // 格式化数据
    $ip = $dou->get_ip();
    
    // 检查IP是否频繁咨询
    if (is_water($ip)) {
        //$wrong['is_water'] = $_LANG['form_is_water'];
    }
    
    // 错误提示
    foreach ($wrong as $item) {
        $data['wrong'] = $item;
        die(json_encode($data));
    }
    
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);

    // 自定义选项
    $data = $dou->fn_query("SELECT * FROM " . $dou->table('form_elements') . " WHERE form_id = '$form_id' ORDER BY id ASC");
    foreach ($data as $row) {
        $post_array[$row['unique_id']] = $_POST[$row['unique_id']];
    }
    $data_box = serialize($post_array);
 
    // 格式化数据
    $add_time = time();
    $back_url = $dou->get_one("SELECT back_url FROM " . $dou->table('form') . " WHERE form_id = '$form_id'");
 
    // 插入报名
    $dou->query("INSERT INTO " . $dou->table('form_data') . " (id, form_id, data_box, ip, add_time)" . " VALUES (NULL, '$form_id', '$data_box', '$ip', '$add_time')");
    
    $data['back_url'] = $back_url;
}

/**
 * +----------------------------------------------------------
 * 防灌水
 * +----------------------------------------------------------
 */
function is_water($ip) {
    $ip = $GLOBALS['dou']->get_ip();
    $unread = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('form_data') . " WHERE ip = '$ip' AND status = 0");
    
    // 如果管理员未回复的咨询数量大于1
    if ($unread >= 1)
        return true;
}

echo json_encode($data);

?>